#include <openssl/bio.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <netdb.h>

#include "netex.h"
#include "config.h"


void netex_init(void)
{
    // OpenSSL
    PRINT_LINE("Initializing OpenSSL...");
    SSL_load_error_strings();
    SSL_library_init();
    OpenSSL_add_all_algorithms();
}
void netex_shutdown(void)
{
    // OpenSSL
    ERR_free_strings();
    EVP_cleanup();
}

int setup_socket(const int port, const char* hostname)
{
    struct addrinfo *cur_addrdinfo;
    struct addrinfo hints_addrinfo = {0};
    int sock_fd = 0;
    hints_addrinfo.ai_family = AF_UNSPEC;
    hints_addrinfo.ai_socktype = SOCK_DGRAM;
    hints_addrinfo.ai_flags = AI_PASSIVE;
    hints_addrinfo.ai_protocol = 0;
    hints_addrinfo.ai_canonname = NULL;
    hints_addrinfo.ai_addr = NULL;
    hints_addrinfo.ai_next = NULL;
    if (getaddrinfo(NULL, hostname, &hints_addrinfo, &cur_addrdinfo) != 0)
    {
        ERROR("Could not get the address info of hostname: '%s'", hostname);
        return 1;
    }
    for (const struct addrinfo* tmp_addrinfo = cur_addrdinfo; tmp_addrinfo != NULL; tmp_addrinfo = tmp_addrinfo->ai_next)
    {
        sock_fd = socket(tmp_addrinfo->ai_family, tmp_addrinfo->ai_socktype, tmp_addrinfo->ai_protocol);
        if (sock_fd == -1)
            continue;

        if (bind(sock_fd, tmp_addrinfo->ai_addr, tmp_addrinfo->ai_addrlen) == 0)
            break; // Succesfull bind to the hostname
        close(sock_fd);
    }
    /*struct sockaddr_in sockaddr;
    const int sockfd = socket(AF_INET, SOCK_STREAM, 0);
    if (sockfd < 0)
    {
        WARN("Failed to create socket!");
        return 1;
    }
    sockaddr.sin_family = AF_INET;
    sockaddr.sin_port = htons(port);
    sockaddr.sin_addr.s_addr = INADDR_ANY;
    const int bind_result = bind(sockfd, (struct sockaddr *)&sockaddr, sizeof(sockaddr));
    if (bind_result != 0)
    {
        const int bind_error = errno;
        ERROR("Failed to bind to socket! Error: %i", bind_error);
        return 1;
    }*/
    return sock_fd;
}